; OpenModPlug To Vortex Tracker Tool...
; Designed to Capture Music Data from one tracker to reformat for another...
; By Karl McNeil
; Bug reports can be sent to KgMcNeil@Yahoo.Com
; Designed originally for Andrew Owen, to help assist conversion of Midi music to the AY chip...
;
; Long Live Worldofspectrum.Org...

#include <GUIConstantsEx.au3>
HotKeySet ( "^p", "PatternGrab" ) ;; Currently using CTRL+P to Scan/Grab OpenModPlug Data...
HotKeySet ( "^d", "DeBug" ) ;; To Be Removed - For debugging only
HotKeySet ( "^s", "SaveDialog" ) ;; CTRL+S to select set SAVE location...
HotKeySet ( "{ESC}", "KillProg" ) ;; In case of run away processes, you can kill program with ESCAPE now...
HotKeySet ( "^r", "ReCompile" ) ;; CTRL+R for ReCompile
HotKeySet ( "{SPACE}", "StopMUSIC" ) ;; SPACEBAR for Stop Music/Silence

Global $ResetInstrument,$IncSpecialCMDS,$ExitID,$TOTAL_Pats,$PatOrder,$newline,$PatLength,$part,$ver,$SamplesUsed,$VTInstrum[32],$InstGUI[32],$InstPLAY[32] ; $InstGUI starts from ZERO, but ZERO is unused here

$ver="v2.00"

Global $Tmp,$Tmp2,$count,$SampleN,$Chan[3][13],$PlayFILE,$TempFILE,$TEMPLATE,$SampleOFFSET,$FINAL_FILE,$RawMOD,$SAVED_COPY
$newline = chr(13) & chr(10)
$RawMOD=""
$SampleN=".123456789ABCDEFGHIJKLMNOPQRSTUV"

$FINAL_FILE=@ScriptDir&"/MODULE.txt" ; Default output for playtesting
$SAVED_COPY=@DesktopDir&"/OutputVT.txt" ; Default name for Saving files
$PlayFILE=@ScriptDir&"/TEMPLATE.txt" ; First file to play on play cmd
$TempFILE=$PlayFILE ; Default Template/Settings file

$Tmp2 = FileOpen($TempFILE)
$TEMPLATE = FileRead($Tmp2)
FileClose($Tmp2)

$SampleOFFSET=StringInStr($TEMPLATE,"[Pattern0]",2,1)+23
;; This is the offset byte to change for altering the sample prior playing the template file...


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Chan Array is [Channel,DataString] = "0_Note", "1_Sample","2_Volume","3_Command","4_Delay","5_HIGH_BYTE","6_LOW_BYTE", "7_Envelope",8_Number(OpenMDT Volume),"9_NUMBER(VibVOL_Boast)","10_Number(VOL_Amplify)","11_Number(VOL_Step)","12_NUMBER(LastNonZeroVOLused)"
;; NB: Chan ARRAY counts from ZERO as BASE NOT ONE!!!! So Channel is 0-2
;; EG: So Channel 1, Note data is actually Chan$[0][0]
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Following Variables need GUI switches ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
$IncSpecialCMDS=1 ;; Include Special Commands?... Including them might add to the number of overall patterns!!! (Included so far: Speed,)

$Chan[0][9]=3
$Chan[1][9]=3
$Chan[2][9]=3   ;; Added to Vibretto VOL to boast prior playing. (0-15)

$Chan[0][10]=1
$Chan[1][10]=1
$Chan[2][10]=1  ;; Each channel has its own additional minimal VT VOL value (0-15)

$Chan[0][11]=0
$Chan[1][11]=0
$Chan[2][11]=0  ;; Each channel has its own VOL Step size to add to Slides (0.00-15.00)

GUICreate("OpenModPlug "&$Ver &"                                                                    By Karl McNeil", 478, 400)  ; will create a dialog box that when displayed is centered
GUICtrlCreateLabel("OpenModPlug To Vortex Tracker Tool "&$Ver,2,2,474,25,0x01+0x1000)
GUICtrlSetFont(-1, 15, 700, 2, "Arial") ; will display italic characters

$VTInstrum=StringMid($TEMPLATE,StringInStr ( $TEMPLATE, "VortexTrackerII=" , 2 , 1 )+16)
$VTInstrum=StringMid($VTInstrum,1,StringInStr ( $VTInstrum, $newline , 2 , 1 )-1)
;; Create Pull Down Instruments

$Tmp=0
$count=0
DO
If $count<30 Then $Tmp=$Tmp+1
DO
$count=$count+1
$InstPLAY[$count]=GUICtrlCreateButton("Smp: "&$count&"=",2+(($tmp-1)*160), 10-(250*($Tmp-1))+($count*25),50,20,0x1200)
$InstGUI[$count]=GUICtrlCreateCombo("",     57+(($Tmp-1)*160), 10-(250*($Tmp-1))+($count*25),100,20) ; create first item
GUICtrlSetData(-1, $VTInstrum, StringMid($VTInstrum,1+StringInStr($VTInstrum,"|",2,$count+1), StringInStr($VTInstrum,"|",2,$count+2)-StringInStr($VTInstrum,"|",2,$count+1)-1))
If $count=31 Then
             $count=40
             $Tmp=4
             EndIf
UNTIL $count=$Tmp*10
UNTIL $Tmp=4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
$count=0 ;; Set Up Default Instrument for the Reset Button
$BUT_Default = GUICtrlCreateButton("Reset to Defaults",2, 285,155,20,0x8F00)
$BUT_NoInstr = GUICtrlCreateButton("Reset to:",      162, 285,50,20,0x8F00)
$ResetInstrument=GUICtrlCreateCombo("",212+5, 285,100,20); Combo list for Reset All instruments switch
GUICtrlSetData(-1, $VTInstrum, StringMid($VTInstrum,1+StringInStr($VTInstrum,"|",2,$count+1), StringInStr($VTInstrum,"|",2,$count+2)-StringInStr($VTInstrum,"|",2,$count+1)-1))


GUICtrlCreateLabel("",2,310,474,5,0x01+0x1000)

$BUT_ReCompile = GUICtrlCreateButton("PLAY",  2, 320,155,30,0x8F00)
$BUT_STOP =  GUICtrlCreateButton("STOP", 162, 320,154,30,0x8F00)
$BUT_SAVE =  GUICtrlCreateButton("SAVE", 321, 320,155,30,0x8F00)

$BUT_About = GUICtrlCreateButton("ABOUT",  2, 320+35,155,30,0x8F00)
$BUT_ReSCAN =  GUICtrlCreateButton("RESCAN", 162, 320+35,154,30,0x8F00)
$BUT_Exit =  GUICtrlCreateButton("EXIT", 321, 320+35,155,30,0x8F00)

GUISetState()

;; GUI now drawn, so lets check to see if OpenModPlug is available with a target song to convert...
;; if so, then jump to Pattern grab... Outershell will have already checked, and passed on the app location & target file in the command line parameter:
If $CmdLine[0] Then 
   Sleep(3000)
   PatternGrab()
   EndIf			;Extra delay to allow OpenModPlug to open fully with loaded song, if autobooting..

ReadGUI()
;--------------- Functions ---------------
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; PROCEDURES FOLLOW ;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Func ReadGUI()  ; Run the GUI until the dialog is closed
WHILE 1
DO
$Tmp=0
$msg = GUIGetMsg()
    Select
     Case $msg = $GUI_EVENT_CLOSE OR $msg = $BUT_Exit
          KillProg()
	  Case $msg = $BUT_SAVE
		  SaveDialog ()
	  Case $msg = $BUT_STOP
		  StopMusic()
	  Case $msg = $BUT_ReSCAN
		  PatternGrab ()
	   Case $msg = $BUT_About
		  PlayMUSIC()
          But_About()
		  StopMusic()
	  Case $msg = $BUT_Default
          But_Default()
     Case $msg = $BUT_NoInstr
          But_NoInstr()
	  Case $msg = $BUT_ReCompile
		  If $RawMOD = "" Then
			  MsgBox(4096, "Scan Some ModPlug Data First!", "Open a song in OpenModPlug Tracker then hit ReScan or CTRL+P to import song data!")
			  Else
		      ReCompile()
			  EndIf
     EndSelect
$count=0
DO
$count=$count+1
If $msg = $InstPLAY[$count] Then
        $Tmp=$count
        $count=31
        EndIf
UNTIL $count=31
UNTIL $Tmp

;;;;;;;PLAY WAVE
;MSGBox (0, "PLAY WAV:", "Playing SLOT "& $Tmp &" using WAV " & StringLeft(GUICtrlRead ($InstGUI[$Tmp]),2))
GUISetState()

$Tmp=StringLeft(GUICtrlRead ($InstGUI[$Tmp]),2); Tmp was slot entry, not its sample contents

;; Opens $TEMPLATE.txt for writing, pokes the instrument into the string (into 3 channels), then overwrites file with the string
$Tmp2=StringLeft($TEMPLATE,$SampleOFFSET)& StringMid($SampleN,$Tmp+1,1) &StringMid($TEMPLATE,$SampleOFFSET+2) ; Poke Channel One
$Tmp2=StringLeft($Tmp2,$SampleOFFSET+14)& StringMid($SampleN,$Tmp+1,1) &StringMid($Tmp2,$SampleOFFSET+2+14) ; Poke Channel Two
$Tmp2=StringLeft($Tmp2,$SampleOFFSET+28)& StringMid($SampleN,$Tmp+1,1) &StringMid($Tmp2,$SampleOFFSET+2+28) ; Poke Channel Three

$count = FileOpen($TempFILE, 2)
FileWrite($count, $Tmp2)
FileClose($count)

$Tmp2=$PlayFILE
$PlayFILE=$TempFILE	
PlayMUSIC()
$PlayFILE=$Tmp2

WEnd
EndFunc   ;==>Example

Func BUT_About()
WinSetState ( "OpenModPlug "&$Ver,"",@SW_HIDE)
MSGBox (0, "How to Use This Tool...", "[0] Open this tool & ModPlug Tracker"&$newline&"[1] Load Song into OpenMDT"&$newline&"[2] Use Instrument panel to change instrument settings (if necessary)"&$newline&"[3] Click ReScan or Press CTRL+P to Scan pattern data"&$newline&"[4] Converted song will autoplay"&$newline&"[5] Save module or adjust instruments according to taste!!!")
WinSetState ( "OpenModPlug "&$Ver,"",@SW_SHOW)
EndFunc

Func BUT_Default()
$count=0
DO
$count=$count+1
GUICtrlSetData($InstGUI[$count], $VTInstrum, StringMid($VTInstrum,1+StringInStr($VTInstrum,"|",2,$count+1), StringInStr($VTInstrum,"|",2,$count+2)-StringInStr($VTInstrum,"|",2,$count+1)-1))
UNTIL $count=31
EndFunc

Func But_NoInstr()
$count=0
DO
$count=$count+1
$Tmp2=Number(StringLeft(GUICtrlRead ($ResetInstrument),2))
GUICtrlSetData($InstGUI[$count], $VTInstrum, StringMid($VTInstrum,1+StringInStr($VTInstrum,"|",2,1+$Tmp2), StringInStr($VTInstrum,"|",2,2+$Tmp2)-StringInStr($VTInstrum,"|",2,1+$Tmp2)-1))
UNTIL $count=31
EndFunc


Func OnYes()
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MPTtoVT pattern CONVERTER           ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Original done in QBasic by ANDROID 2011
;; AutoIT script by KGMcNeil Apr 1st 2012
;;
;; Now radically rewritten...
;;
;; [1] Open this tool
;; [2] Load your music in OpenModPlug Tracker
;; [3] Click on "Patterns" Tab in OpenModPlug
;; [4] Press CTRL+P
;; [5] Music will be converted to Vortex Tracker Text Module!
;;

Local $header,$marker,$IN,$Offset,$len,$OUT,$line,$Notes

$SamplesUsed=0

$marker = "|"
$IN = $RawMOD
$Offset=StringInStr($IN, $newline,0,1)+1
$header=StringLeft($IN,$Offset)
$len=StringInStr ( $IN, $newline, 0,2) - $Offset +1
$PatLength=1

$Notes = 0
$OUT = ""
$line = "1"
$part = 0
$Tmp = ""

DO
$line = StringMid($IN, $Offset, $len)

If StringInStr ( $line, $header) Then	;; Skip Headers, if multiple patterns fed to it
	$Offset = $Offset + StringLen($header)
	$line = StringMid($IN, $Offset, $len)
	$PatLength=1
	EndIf
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Creating Blanks ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
$count=0
DO
$Tmp=0
DO
$Chan[$count][$Tmp]="."
$Tmp=$Tmp+1
UNTIL $Tmp=8
$count=$count+1
UNTIL $count=3
;;;;;;;;;;;;;;;;;;;;;;;;;;;


$count=0
DO
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; First the NOTES...
$Chan[$count][0] = StringMid($line, 1+StringInStr($line,$marker,0,1+$count), 3)
$Chan[$count][0] = StringReplace($Chan[$count][0], "...", "---")
$Chan[$count][0] = StringReplace($Chan[$count][0], "===", "R--")

;; Now the Instruments/Samples
$Chan[$count][1]="."
$Tmp=Number(StringMid($line, 4+StringInStr($line,$marker,0,1+$count), 2))

   If $Tmp And $Tmp>$SamplesUsed Then
		$SamplesUsed=$Tmp		; Counting the number of Samples used
		EndIf

;;; THIS IS IN DEVELOPMENT: $Tmp=Number(StringLeft(GUICtrlRead ($InstGUI[$Tmp]),2)) ; this exchanges the instruments

If $Tmp Then
   $Chan[$count][1]=StringMid($SampleN,$Tmp+1,1) ;; Write the Sample Referrence (1-31)
   EndIf

;; Command Checks - WARNING - These may add to your unique pattern count!!!
;; Now some commands for Speed...
If $IncSpecialCMDS Then
$Tmp=StringMid($line, 9+StringInStr($line,$marker,0,1+$count), 3)
$Tmp2=StringLeft($Tmp,1)
;;;;;;;;;;;;;;;;;;;;
;; Speed commands ;;
;;;;;;;;;;;;;;;;;;;;
If $Tmp2="F" Then   ;; Assume its a Speed Command!!!
             $Tmp=StringReplace($Tmp,"0",".")
             $Chan[$count][3]="B"
             $Chan[$count][5]=StringMid($Tmp,2,1)
             $Chan[$count][6]=StringRight($Tmp,1)
             EndIf
;;;;;;;;;;;;;;;;;;;;;
;; VOLUME commands ;;
;;;;;;;;;;;;;;;;;;;;;
If $Tmp2="C" Then ;; Simple Set Volume Command.
             $Tmp2=StringTrimLeft($Tmp,1)
             $Tmp2=Dec($Tmp2)
             $Chan[$count][8]=$Tmp2 ;; Set Volume
             Calc_VOL()
             EndIf

$Tmp2=StringLeft($Tmp,2)
If StringInStr("EA,A0,EB,50,60",$Tmp2,1) Then ;; Volume Slide DOWN Command.
             $Tmp2=StringRight($Tmp,1)
             $Tmp2=Dec($Tmp2)
             If StringLeft($Tmp,2)="EA" Then $Tmp2=$Tmp2*-1 ;; Create an Exception for EA code, which is Volume UP
             $Chan[$count][8]=$Chan[$count][8]-$Tmp2 ;; Decrease Volume
             Calc_VOL()
             Else

$Tmp2=StringLeft($Tmp,1)
If StringInStr("A,5,6",$Tmp2,1) Then ;; Volume Slide UP Command.
             $Tmp2=StringMid($Tmp,2,1)
             $Tmp2=Dec($Tmp2)
             $Chan[$count][8]=$Chan[$count][8]+$Tmp2 ;; Increase Volume
             Calc_VOL()
             EndIf
             EndIf

;;;;;;;;;;;;;;;;;;;;;;;;
;;; Vibrato Commands ;;;
;;;;;;;;;;;;;;;;;;;;;;;;
$Tmp2=StringLeft($Tmp,1)
If $Tmp2="4" And StringRight($Chan[$count][0],2)<>"--" And StringRight($Tmp,2)<>"0" Then ;; Vibretto
             $Chan[$count][5]=Number(StringMid($Tmp,2,1))
             $Chan[$count][5]=Abs(16-$Chan[$count][5])

             $Chan[$count][6]=Number(StringRight($Tmp,1))
             $Chan[$count][6]=abs($Chan[$count][5]-($Chan[$count][6]-1))

             $Chan[$count][5]=StringMid($SampleN,$Chan[$count][5]+1,1)
             $Chan[$count][6]=StringMid($SampleN,$Chan[$count][6]+1,1)

             If $Chan[0][9] Then ;; Boast Volume if Default >0 Else assume last channel Volume
                            $Chan[$count][2]=$Chan[$count][12]+$Chan[$count][9]
                                If $Chan[$count][2]>15 Then $Chan[$count][2]=15
                            $Chan[$count][2]=StringMid($SampleN,$Chan[$count][2]+1,1)
                            EndIf
             $Chan[$count][3]="6";; VT Vibreto Cmd
             EndIf
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pitch Sliding Commands ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
If $Tmp2="1" Then ;; Regular Slide Pitch UP
             $Tmp2=StringRight($Tmp,2)
             $Chan[$count][4]="1"
             $Tmp=StringReplace($Tmp,"0",".")
             $Chan[$count][5]=StringMid($Tmp,2,1)
             $Chan[$count][6]=StringRight($Tmp,1)
             $Chan[$count][3]="2";; Pitch Bend UP
             EndIf

If $Tmp2="2" Then ;; Regular Slide Pitch DOWN
             $Tmp2=StringRight($Tmp,2)
             $Chan[$count][4]="1"
             $Tmp=StringReplace($Tmp,"0",".")
             $Chan[$count][5]=StringMid($Tmp,2,1)
             $Chan[$count][6]=StringRight($Tmp,1)
             $Chan[$count][3]="1";; Pitch Bend DOWN
             EndIf

;If $Tmp2="3" Then ;; Portamento     ;; NEEDS WORK!.. Doesn't sound right yet!
;             $Tmp2=StringRight($Tmp,2)
;             $Chan[$count][4]="5"
;             $Tmp=StringReplace($Tmp,"0",".")
;             $Chan[$count][5]=StringMid($Tmp,2,1)
;             $Chan[$count][6]=StringRight($Tmp,1)
;             $Chan[$count][3]="3";; VT Portamento Cmd
;             EndIf

$Tmp2=StringLeft($Tmp,2)
If $Tmp2="E1" Then ;; Fine Slide Pitch UP
             $Tmp2=StringRight($Tmp,1)
             $Chan[$count][6]=$Tmp2
             $Chan[$count][3]="2";; Pitch Bend UP
             EndIf

If $Tmp2="E2" Then ;; Fine Slide Pitch DOWN
             $Tmp2=StringRight($Tmp,1)
             $Chan[$count][6]=$Tmp2 ;; Stuff Value on low parametre byte
             $Chan[$count][3]="1";; Pitch Bend DOWN
             EndIf
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EndIf ;; for Special Commands ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
$count=$count+1
UNTIL $count=3

$Tmp="....|..|"
$count=0
DO
$Tmp=$Tmp & $Chan[$count][0] & " " & $Chan[$count][1]&$Chan[$count][7]&"."&$Chan[$count][2]&" "& $Chan[$count][3]&$Chan[$count][4]&$Chan[$count][5]&$Chan[$count][6]&"|"
$count=$count+1
UNTIL $count=3
$Tmp=StringTrimRight($Tmp,1); Trim last character off

If $Notes = 64 Then ;; This breaks down large midi tracks into 64 row patterns
   $part = $part +1
   $PatLength=$PatLength+1
   $Tmp = $newline & "[Pattern" & $part & "]" & $newline & $Tmp
   $Notes = 0
   EndIf

If StringLen ( $line ) = $len Then
	$OUT=$OUT & $Tmp & $newline
	$Notes = $Notes +1
    Else
    $Tmp = ""
    EndIf

$Offset = $Offset + $len

Until $Tmp = ""

ClipPut ($OUT)
Beep (500,200)
EndFunc   ;==>OnYes

Func OnExit()
		Exit
EndFunc   ;==>OnExit

Func PatternGrab()
StopMUSIC(); Preparing for Saving to music file (in case its in use!)

If WinExists("OpenMPT") Then
WinSetState ( "OpenModPlug "&$Ver,"",@SW_HIDE)
WinActivate("OpenMPT")
    Sleep(500)
    Send("!p")
	Send("^{TAB}")

GUISetState()
Local $Tmp,$IN

DO
Send("{TAB}")
Send("^{TAB}")
Send("{HOME}")

Send("^5")
Send("^c")
$IN=ClipGet()	;; Grab Pattern Order info
Until StringInStr ( $IN, "OrdLst")

$PatOrder=StringTrimLeft ( $IN, (StringInStr($IN, $newline,0,2)+8) )
$TOTAL_Pats=StringTrimLeft ( $IN, (StringInStr($IN, $newline,0,1)+9) )

$Tmp=StringInStr($TOTAL_Pats, $newline,0,1)-1
$TOTAL_Pats=Number(StringLeft ($TOTAL_Pats, $Tmp)) ; Total patterns calculated


Send("{HOME}")
Send("{TAB}")

$IN=""
$Tmp=$TOTAL_Pats
DO
Send("^5")
;Beep (200,70)
Send("^c")
Beep (300,30)
$IN=$IN & ClipGet()
Beep (400,30)
Send("^{RIGHT}")
$Tmp = $Tmp -1
Until $Tmp = 0

$RawMOD=$IN ; This is the raw data, which can now be recompiled, without need to rescan for it...
Send("^")
Beep (400,70)
ReCompile()
Else
   MsgBox(0,"OpenModPlug currently inactive!","Load a song into OpenModPlug BEFORE scanning for pattern data!")
EndIf
EndFunc


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Func CreateVT()
Local $Tmp, $count,$Tmp2,$CurrentPAT,$Repeat,$clone,$IN,$PatString,$Pattern
$Tmp=""
$Tmp=$Tmp & "[Module]" & $newline
$Tmp=$Tmp & "VortexTrackerII=1" & $newline
$Tmp=$Tmp & "Version=3.6" & $newline
$Tmp=$Tmp & "Title=Ported by OpenMPT2VT "&$ver& $newline
$Tmp=$Tmp & "Author="&$part& " Patterns (%U% Unique) & "& $SamplesUsed & " Samples" & $newline
$Tmp=$Tmp & "NoteTable=1" & $newline
$Tmp=$Tmp & "ChipFreq=1750000" & $newline
$Tmp=$Tmp & "Speed=3" & $newline
$Tmp=$Tmp & "PlayOrder=L"

$count=0 ; Creating Pattern Order list - very simple range from 0 to $part
DO
$Tmp=$Tmp & $count & ","
$count=$count+1
Until $count=$part
$Tmp=StringTrimRight($Tmp,1) & $newline & $newline ; Trim last comma & Tidy

$count=1 ; Creating simple Ornament data
DO
$Tmp=$Tmp & "[Ornament" & $count & "]" & $newline & "L0" & $newline & $newline
$count=$count+1
Until $count=16

;; Now to create the Samples...
$count=1
DO
$IN=Number(StringLeft(GUICtrlRead ($InstGUI[$count]),2)) ; Reading the Sample slots...

If $IN Then ;; If Sample slot is empty (0), then skip searching for it!
  $Tmp2=StringMid($TEMPLATE,StringInStr ( $TEMPLATE, "[Sample"&$IN&"]", 2 ,1 ))
  $Tmp2=StringMid($Tmp2,1,StringInStr ( $Tmp2, "[", 2 ,2 )-1)
  $Tmp2=StringReplace ( $Tmp2, "[Sample"&$IN&"]","[Sample"&$count&"]")
  Else
	  $Tmp2="[Sample" & $count & "]" & $newline & "tne +000_ +00_ 0_ L" & $newline & $newline; Filling a blank for an empty sample slot
  EndIf

$Tmp=$Tmp&$Tmp2
$count=$count+1
Until $count>$SamplesUsed

DO
$Tmp=$Tmp & "[Sample" & $count & "]" & $newline & "tne +000_ +00_ 0_ L" & $newline & $newline
$count=$count+1
Until $count=32

$Tmp=$Tmp & "[Pattern0]" & $newline
$Tmp2=ClipGet()						; Now to append the pattern data...
$Tmp=$Tmp & $Tmp2
;ClipPut($Tmp)		; Done! Data is in the Clipboard, Now its time to SAVE it!!!
Send("^")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PATTERN CULLING FROM HERE ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Find and Replace Patterns within Vortex Modules ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; ...An Extension to OpenMDT2VT
;;
;; By Karl McNeil
;; March 31st 2012

$IN=$Tmp ; The whole TextModule

$TOTAL_Pats = $part

; Create $PatString
$PatString=""
$count=-1
DO
$count=$count+1
$PatString=$PatString & Chr($count)
UNTIL $count=$TOTAL_Pats ; $patString now contains a list of chrs from 0 to TOTAL_Patterns

$CurrentPAT = -1
DO
$CurrentPAT = $CurrentPAT +1
$Pattern=StringInStr($IN,"[Pattern"& $CurrentPAT &"]",0,1) ; find Header
$Pattern=2+StringInStr($IN, $newline,0,1,$Pattern); find start of data past header
$Pattern=StringMid($IN,$Pattern,3264); $pattern now holds the whole pattern to compare minus the header

DO
$Repeat=StringInStr($IN,$pattern,0,2)
If $Repeat Then ; BackTrack to Header to identify clone pattern

	$clone=Number(StringMid($IN,1+StringInStr($IN,"n",1,1,$Repeat-8),(StringInStr($IN,"]",1,1,$Repeat-8)- StringInStr($IN,"n",1,1,$Repeat-8))))
	$PatString=StringReplace ( $PatString, chr($clone), chr($CurrentPAT)) ; All clones ref's replaced by originals in OrdList string
	$IN=StringReplace ( $IN, $newline&"[Pattern"&$clone&"]"& $newline & $Pattern, "", 0, 2); Destroy all traces of titled clone pattern from module
	EndIf
UNTIL $Repeat=0
UNTIL $CurrentPAT = $TOTAL_Pats

; Now ReNumbering the order list...
$Tmp2=0 ; Unique Patterns
$count=-1
DO
$count=$count+1
$Pattern="[Pattern"&$count&"]"
$Repeat=StringInStr($IN,$pattern,0,1)
If $Repeat Then
   $IN=StringReplace ( $IN, $Pattern, "[Pattern"&$Tmp2&"]", 0, 2)
   $PatString=StringReplace ( $PatString, chr($count), chr($Tmp2))
   $Tmp2=$Tmp2+1
   EndIf
UNTIL $count=$TOTAL_Pats
$IN=StringReplace ( $IN, "%U%", $Tmp2, 0, 2) ;; Insert Referrence at Top of Module

; Create the new OrdList:
$Pattern=""
$count=0
DO
$Pattern=$Pattern & ASC(StringMid($PatString,$count+1,1)) & ","
$count=$count+1
UNTIL $count=$TOTAL_Pats
$Pattern=StringTrimRight($Pattern,1) ; remove excess comma
$Pattern="PlayOrder=L" & $Pattern

; Find and replace old order list:
$clone = StringMid ( $IN, StringInStr($IN,"PlayOrder",0,1),(StringInStr($IN,$newline,0,1,StringInStr($IN,"PlayOrder",0,1))-StringInStr($IN,"PlayOrder",0,1)) )
$IN=StringReplace ( $IN, $clone, $Pattern, 1,2) & $newline  ; Replace Orderlist & add final newline
;; Finally put it all back in clipboard
ClipPut($IN)
$Tmp=$IN
Send("^")
Beep(800,100)

;;;;;;;;;;;;;;;;;;; ;;;;;;;;;;;
;; FILE SAVING ;;;; ;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;; ;;;;;;;;;;;
$count = FileOpen($FINAL_FILE, 2)
; Check if file opened for writing OK
If $count = -1 Then
    MsgBox(0, "Error", "Unable to open file.")
    Exit
    EndIf
FileWrite($count, $Tmp)
FileClose($count)
Send("^")
$Tmp=0

WinSetState ( "OpenModPlug "&$Ver,"",@SW_SHOW)
	WinActivate("OpenModPlug")

$PlayFILE=$FINAL_FILE
PlayMUSIC()
EndFunc

Func DeBug()
MSGBOX(0,"title","Maintest")
EndFunc

Func Calc_VOL()
;; This is your Volume Formula, used by various volume commands...
;; Ensure your Channel Volume Variable is set ($Chan[$count][8]), then it will do the rest...
             If $Chan[$count][8]<1 Then $Chan[$count][8]=0   ;; Limit checking for OpenMDT data
             If $Chan[$count][8]>64 Then $Chan[$count][8]=64 ;; Limit checking for OpenMDT data
$Tmp2=$Chan[$count][10]+ROUND($Chan[$count][8]*($Chan[$count][11]+(16/64))) ;; Poke VT value according to OpenMDT Channel Volume
             If $Tmp2>15 Then $Tmp2=15     ;; MORE Limit checking, This time for the overall VT volume
             If $Tmp2>0 Then
                      $Chan[$count][2]=StringMid($SampleN,$Tmp2+1,1)
                      $Chan[$count][12]=$Tmp2  ;; Notes last Non-Zero Volume used, so other commands to can use it...
                      Else
                      $Chan[$count][0]="R--" ; Sound that is below threshold is considered silent (Not likely if $VOL_AMPLIFY>0)
                      EndIf
EndFunc

Func PlayMUSIC()
   StopMusic()
   ShellExecute (@ScriptDir&"\zxtune123.exe"," "&FileGetShortName($PlayFILE)&" --ym --silent",@ScriptDir,"open",@SW_HIDE)
   EndFunc

Func StopMUSIC()
   ProcessClose ("zxtune123.exe")
   EndFunc
Func KillProg()
Send("^")
StopMUSIC()
EXIT
EndFunc


Func SaveDialog()
	$SAVED_COPY = FileSaveDialog( "Select where to Save your Vortex Tracker output", $SAVED_COPY, "Vortex Text Module (*.txt)", 2,$SAVED_COPY)
; option 2 = dialog remains until valid path/file selected

If @error OR $SAVED_COPY="" Then
    Beep(500,200)
Else
If StringInStr ( $SAVED_COPY, ".txt",1) = 0 Then
$SAVED_COPY=$SAVED_COPY & ".txt" ; Add extension if user doesn't add it...
EndIf
EndIf
FileCopy($FINAL_FILE,$SAVED_COPY,9); Saved!!!
EndFunc

Func ReCompile()
	StopMUSIC(); Yes, we need to shut it up prior resaving data!
OnYes() ;; Main conversion routine...
CreateVT()
	EndFunc